//
//  ASP51NV2SDKErrorModel.h
//  AS-P51N_SDK
//
//  Created by Yasutaka Oshiro on 2019/01/29.
//  Copyright © 2019年 Robin. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSUInteger, ASP51NErrorCode) {
    ASP51NErrorCodeUnknown = 0,
    ASP51NErrorCodeNil_Instance,
    ASP51NErrorCodeNil_ArgumentValue,
    ASP51NErrorCodeCommon_TCPNotConnect,
    ASP51NErrorCodeCommon_FHLBTReadTimeInvalidRange,
    ASP51NErrorCodeCommon_FHLBTIdleTimeInvalidRange,
};

@interface ASP51NErrorModel : NSObject
// 通常エラー用
+ (NSError *)createErrorWithCode:(ASP51NErrorCode)code;
// メソッド名とインスタンス名指定用
+ (NSError *)createErrorWithMethodName:(NSString *)methodName instanceNema:(NSString *)instanceName code:(ASP51NErrorCode)code;
// インスタンス名指定用
+ (NSError *)createErrorWithInstanceNema:(NSString *)instanceName code:(ASP51NErrorCode)code;
@end
