//  AboutController.m
//
#import "InfroController.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>
#import "Utils.h"
@interface InfroController()
{
     
}


@property (weak, nonatomic) IBOutlet UILabel *olSDKVersion;
@property (weak, nonatomic) IBOutlet UILabel *olAppVersion;
@property (strong, nonatomic) IBOutlet UILabel *olFWVersion;
@end

@implementation InfroController

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASP51NV2 sharedInstance].delegate = self;
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:YES];
    [ASP51NV2 sharedInstance].delegate = nil;
}

- (void)viewDidAppear:(BOOL)animated
{
    [Utils showLoadingView:@"Check Reader Info" timeOut:df_TIMEOUT_DEFAULT];
    [self.olAppVersion setText:[self getAppVersion]];
    [self.olSDKVersion setText: [[ASP51NV2 sharedInstance] getSDKVersion]];
    [[ASP51NV2 sharedInstance] getFirmwareVersion];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

/* APP version */
- (NSString *)getAppVersion
{
    NSDictionary *infoDictionary = [[NSBundle mainBundle] infoDictionary];
    NSString *majorVersion = [infoDictionary objectForKey:@"CFBundleShortVersionString"];
    NSString *minorVersion = [infoDictionary objectForKey:@"CFBundleVersion"];
    return [NSString stringWithFormat:@"%major :%@ (%@)", majorVersion, minorVersion];
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedFirmwareVersion:(NSString *)firmwareVersion executionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [self.olFWVersion setText:firmwareVersion];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Get FirmwareVersion Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}
@end
