//  KillController.m

#import "KillController.h"
#import "SelectedTagInfo.h"
#import "Utils.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>
#import "PhyUtility.h"

@interface KillController ()<ASP51NV2Delegate>

@property (weak, nonatomic) IBOutlet UITextField *olTargetEpc;
@property (weak, nonatomic) IBOutlet UITextField *olKillPassword;

@end

@implementation KillController

#pragma mark - Lifecycle
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASP51NV2 sharedInstance].delegate = self;
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    self.olTargetEpc.text =  selectTag.selectedTagEPC;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - IBAction
- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [self.olTargetEpc resignFirstResponder];
    NSString *hexaString = self.olKillPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    uint32_t killpassword;
    [pScanner scanHexInt: &killpassword];
    NSData *epcs = [self.olTargetEpc.text hexStringToBytes];
    [[ASP51NV2 sharedInstance] killTagWithKillPassword:killpassword EPC:epcs];
}

#pragma mark - ASP51NV2Delegate
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didKillTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [Utils showAlert:@"Success" message:@"Killed" view:self];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Killed Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 changeNetworkState:(ASP51NV2NetworkState)state error:(NSError *)error
{
    switch (state) {
        case ASP51NV2NetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
        case ASP51NV2NetworkStateError:
            break;
        default:
            break;
    }
}
@end
