//  LockController.m

#import "LockController.h"
#import "SelectedTagInfo.h"
#import "Utils.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>
#import "PhyUtility.h"
@interface LockController ()<ASP51NV2Delegate>

@end

@implementation LockController

#pragma mark - Lifecycle
- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    self.olTargetEpc.text =   selectTag.selectedTagEPC;
    [ASP51NV2 sharedInstance].delegate = self;
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASP51NV2 sharedInstance].delegate = nil;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - IBAction
- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [self.olTargetEpc resignFirstResponder];

    NSString *hexaString = self.olAccessPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    uint32_t accesspassword;
    [pScanner scanHexInt: &accesspassword];

    uint32_t lock = 0;
    uint32_t seed = (uint32_t)self.olAction.selectedSegmentIndex;

    switch (self.olTargetMemory.selectedSegmentIndex) {
        case 0: // Kill
            lock = (seed << 8) | (3 << 18);
            break;
        case 1: // Access
            lock = (seed << 6) | (3 << 16);
            break;
        case 2: // EPC
            lock = (seed << 4) | (3 << 14);
            break;
        case 3: // TID
            lock = (seed << 2) | (3 << 12);
            break;
        case 4: // USER
            lock = (seed << 0) | (3 << 10);
            break;
        default:
            break;
    }

    NSData *epcs       = [self.olTargetEpc.text hexStringToBytes];
    [[ASP51NV2 sharedInstance] lockTagWithAccessPassword:accesspassword EPC:epcs targetMemory:self.olTargetMemory.selectedSegmentIndex lockAction:self.olAction.selectedSegmentIndex];

}

#pragma mark - ASP51NV2SDK Delegate
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didLockTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [Utils showAlert:@"Success" message:@"Lock Tag" view:self];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Lock Tag Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 changeNetworkState:(ASP51NV2NetworkState)state error:(NSError *)error
{
    switch (state) {
        case ASP51NV2NetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
        case ASP51NV2NetworkStateError:
            break;
        default:
            break;
    }
}
@end
