//
//  ModelViewController.m
//  P51NV2Demo
//
//  Created by mac on 2019/8/2.
//  Copyright © 2019年 Robin. All rights reserved.
//

#import "ModelViewController.h"
#import "Utils.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>

@interface ModelViewController ()<ASP51NV2Delegate>
{
    int selectedSession;
}

@end

@implementation ModelViewController

#pragma mark - Lifecycle
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASP51NV2 sharedInstance].delegate = self;
    
    [self performSelector:@selector(onTickGetModel)   withObject:nil afterDelay:.4f];
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASP51NV2 sharedInstance].delegate = nil;
}

#pragma mark - Private Method
- (void)onTickGetModel
{
//    zzz
//    NSError *error =
    [[ASP51NV2 sharedInstance] getRFMode];
//    if( error ){
//        NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
//    }
}

#pragma mark - ASP51NV2SDK Delegate
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didSetRFModeExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [Utils showAlert:@"Success" message:@"RFMode changed" view:self];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"RFMode changed Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedRFMode:(ASP51NV2RFModeType)RFMode executionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        selectedSession = RFMode;
        dispatch_async(dispatch_get_main_queue(),^{
            [self.tableView reloadData];
        });
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"RFMode Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 changeNetworkState:(ASP51NV2NetworkState)state error:(NSError *)error
{
    switch (state) {
        case ASP51NV2NetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
        case ASP51NV2NetworkStateError:
            break;
        default:
            break;
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}

#pragma mark - TableView DataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 4;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    cell.textLabel.text = [NSString stringWithFormat:@"RFMODE%d", (int)indexPath.row];
    
    if(selectedSession == indexPath.row)
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    else
        cell.accessoryType = UITableViewCellAccessoryNone;
    return cell;
}

#pragma mark - TableView Delegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    selectedSession = (int)indexPath.row;
    [self.tableView reloadData];
}

#pragma mark - IBAction
- (IBAction)onClickButtonDone:(id)sender {
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    ASP51NV2RFModeType type;
    switch (selectedSession) {
        case 0:
            type = ASP51NV2RFModeType_E0;
            break;
        case 1:
            type = ASP51NV2RFModeType_E1;
            break;
        case 2:
            type = ASP51NV2RFModeType_E2;
            break;
        case 3:
            type = ASP51NV2RFModeType_E3;
            break;
        case 4:
            type = ASP51NV2RFModeType_E4;
            break;
        default:
            type = ASP51NV2RFModeType_E0;
            break;
    }
//    zzz
//    NSError *error =
    [[ASP51NV2 sharedInstance] setRFMode:type];
//    if( error ){
//        NSLog(@"%@\n code = %d\n%@", NSStringFromSelector(_cmd), (int)error.code, error.userInfo);
//    }
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
