//
//  TagViewController.m

#import "TagViewController.h"
#import "CustomCell.h"
#import "TagModel.h"
#import "TagAccessController.h"
#import "SelectedTagInfo.h"

@interface TagViewController ()
{
    TagModel *tagModel;
}
@end

@implementation TagViewController

-(void)updateData
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.tableView reloadData];
    });
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    tagModel = [TagModel sharedInstance];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    int count = (int)[tagModel.arrTags count];
    return  count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    CustomCell      *cell           = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
   
    NSDictionary *dic = [tagModel.arrTags objectAtIndex:[indexPath row]];
    
    NSString *epEpc = [dic valueForKey:df_CELL_TAG_INFO];
    NSString *count = [dic valueForKey:df_CELL_TAG_COUNT];
    NSString *ant = [dic valueForKey:df_CELL_TAG_ANT];
   
    cell.tagAnt.text                = [NSString stringWithFormat:@"ANT : %@",ant];
    cell.tagHex.text                = epEpc;
    cell.tagCount.text              = count;
    return cell;
}

#pragma mark - Table view delegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    NSDictionary *dic = [tagModel.arrTags objectAtIndex:[indexPath row]];
    
    NSData* pcEpc   = [dic valueForKey:df_CELL_TAG_RAW];
    NSMutableString* tag = [[NSMutableString alloc]init] ;
    unsigned char* ptr= (unsigned char*) [pcEpc bytes];
    
    for(int i = 2; i < pcEpc.length; i++)
        [tag appendFormat:@"%02x", ptr[i] & 0xFF ];
    
    selectTag.selectedTagEPC = tag;
    
    TagAccessController *tagView = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"ID_TagAcessView"];
    [self.navigationController pushViewController:tagView animated:YES];
}

@end
