#import "ViewController.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>
#import "SVProgressHUD.h"
#import "Utils.h"
#import "TagModel.h"
#import "TagViewController.h"
typedef NS_ENUM(NSUInteger,NetWrokState) {
    NetworkConnected,
    NetworkDisConnected,
    NetworkError,
};
@interface ViewController ()<ASP51NV2Delegate>
{
    NSMutableArray *arrIPs;
    NSString *selectIP;
    TagModel *tagModel;
    SystemSoundID soundFileObject;
    ASP51NV2 *mngr;
    NSInteger _countNum;
}
-(IBAction)btnSearchDevice:(id)sender;
-(IBAction)btnRead:(id)sender;
-(IBAction)btnStop:(id)sender;
-(IBAction)btnClear:(id)sender;
-(IBAction)btnCheckAnt:(id)sender;
@property (nonatomic,retain) IBOutlet UIBarButtonItem *btnMore;
@property (strong, nonatomic) IBOutlet UIBarButtonItem *btnNetwork;
@property (strong, nonatomic) IBOutlet UIButton *btnSearch;
@property (nonatomic,retain) IBOutlet UIButton *btnRead;
@property (nonatomic,retain) IBOutlet UILabel *labelIP;
@property (nonatomic,retain) IBOutlet UILabel *labelTags;
@property (weak, nonatomic) IBOutlet UILabel *labelCount;
@property (nonatomic,retain) IBOutlet UIView *viewBottom;
@property (nonatomic,retain) IBOutlet UIButton *btnCheckAnt1;
@property (nonatomic,retain) IBOutlet UIButton *btnCheckAnt2;
@property (nonatomic,retain) IBOutlet UIButton *btnCheckAnt3;
@property (nonatomic,retain) IBOutlet UIButton *btnCheckAnt4;
@property (weak, nonatomic) IBOutlet UIButton *setButton;
@property (weak, nonatomic) IBOutlet UIButton *getButton;

@property (nonatomic, strong) TagViewController            *tagViewController;
@end


@implementation ViewController
{
    BOOL ant1;
    BOOL ant2;
    BOOL ant3;
    BOOL ant4;
}
#pragma mark - segue
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"segueTagTableView"])
    {
        self.tagViewController = segue.destinationViewController;
    }
}
-(IBAction)btnCheckAnt:(id)sender
{
    if (ant1) {
        ant1 = NO;
        [_btnCheckAnt1 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
    } else {
        ant1 = YES;
        [_btnCheckAnt1 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
    }
}
- (IBAction)btnCheckAnt2:(id)sender {
    if (ant2) {
        ant2 = NO;
        [_btnCheckAnt2 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
    } else {
        ant2 = YES;
        [_btnCheckAnt2 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
    }
}
- (IBAction)btnCheckAnt3:(id)sender {
    if (ant3) {
        ant3 = NO;
        [_btnCheckAnt3 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
    } else {
        ant3 = YES;
        [_btnCheckAnt3 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
    }
}
- (IBAction)btnCheckAnt4:(id)sender {
    if (ant4) {
        ant4 = NO;
        [_btnCheckAnt4 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
    } else {
        ant4 = YES;
        [_btnCheckAnt4 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
    }
}
- (IBAction)onClickSetButton:(id)sender {
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [mngr setAntennaPortsStatusWithAntenna1:ant1 antenna2:ant2 antenna3:ant3 antenna4:ant4];
}

- (IBAction)onClickGetButton:(id)sender {
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [mngr getAntennaPortsStatus];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.btnMore setEnabled:NO];
    [self setUpSound];
    ant1 = NO;
    ant2 = NO;
    ant3 = NO;
    ant4 = NO;
    _countNum = 0;
    [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeBlack];
    
}


- (void)viewWillAppear:(BOOL)animated
{
    tagModel = [TagModel sharedInstance];
    if(arrIPs == nil)
        arrIPs  = [[NSMutableArray alloc]init];
    mngr =  [ASP51NV2 sharedInstance];
    mngr.delegate = self;
    
    NSString* version = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    self.title =  [NSString stringWithFormat:@"AsReader(A:%@/S:%@)",version,[mngr getSDKVersion]];
}



- (void)viewDidDisappear:(BOOL)animated
{
    [self btnStop:nil];
}


-(IBAction)btnSearchDevice:(id)sender
{
    [SVProgressHUD showWithStatus:@"Searching..."];
    [arrIPs removeAllObjects];
    [mngr startSearchDevice];
}


-(IBAction)btnRead:(id)sender
{
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [mngr startInventoryWithEPC:YES TID:YES PC:YES RSSI:YES phase:YES channel:YES antenna:YES];
}

-(IBAction)btnStop:(id)sender
{
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [mngr stopInventory];
}


-(IBAction)btnClear:(id)sender
{
    _countNum = 0;
    [tagModel.arrTags removeAllObjects];
    [self.labelTags setText:[NSString stringWithFormat:@"%d Tags",(int)[tagModel.arrTags count]]];
    [self.labelCount setText:[NSString stringWithFormat:@"%ld", (long)_countNum]];
    [self.tagViewController updateData];
}

- (void)setUpSound
{
    NSURL *tapSound = [[NSBundle mainBundle] URLForResource:@"read" withExtension:@"caf"];
    CFURLRef soundFileURLRef = (__bridge CFURLRef)tapSound;
    AudioServicesCreateSystemSoundID (soundFileURLRef, &soundFileObject);
}

- (void)playBeepSound
{
    AudioServicesPlaySystemSound(soundFileObject);
}


- (void)readerConnected:(uint8_t)status
{
    if(status == 0x00)
        [Utils showAlert:@"Newtwork Connected" message:@"RFID did power ON" view:self];
}

- (void)stoppedReadTags:(uint8_t)statusCode
{
    NSLog(@"Stop Scan");
}

#pragma mark - ASP51NV2SDKSDK Delegate
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 searchingIP:(NSString *)IP isFinish:(BOOL)isFinish
{
    if(isFinish == YES)
    {
        if ([SVProgressHUD isVisible])
            [SVProgressHUD dismiss];
        
        if ([arrIPs count]>0)
            [self showAlertViewIPs];
        else
            [Utils showAlert:@"Search" message:@"Not found Devices" view:self];
    } else {
        [arrIPs addObject:IP];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 changeNetworkState:(ASP51NV2NetworkState)state error:(NSError *)error
{
    switch (state) {
        case ASP51NV2NetworkStateConnected:
            [self enableUis:YES];
            [Utils showLoadingView:@"Setting" timeOut:df_TIMEOUT_DEFAULT];
            break;
        case ASP51NV2NetworkStateDisconnected:
            [self enableUis:NO];
            [Utils showAlert:@"Network" message:@"Disconnected" view:self];
            break;
        case ASP51NV2NetworkStateError:
            [self enableUis:NO];
            [Utils showAlert:@"Network" message:@"Fail connected" view:self];
            break;
        default:
            break;
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    self.btnNetwork.enabled = YES;
    self.btnMore.enabled = YES;
    self.btnSearch.enabled = YES;
    self.btnCheckAnt1.enabled = YES;
    self.btnCheckAnt2.enabled = YES;
    self.btnCheckAnt3.enabled = YES;
    self.btnCheckAnt4.enabled = YES;
    self.setButton.enabled = YES;
    self.getButton.enabled = YES;
    self.tagViewController.tableView.allowsSelection = YES;
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedInventoryDataWithRSSI:(NSString *)RSSI channel:(NSString *)channel phase:(NSString *)phase antenna:(NSString *)antenna PC:(NSString *)PC EPC:(NSString *)EPC TID:(NSString *)TID
{
    self.btnNetwork.enabled = NO;
    self.btnMore.enabled = NO;
    self.btnSearch.enabled = NO;
    self.btnCheckAnt1.enabled = NO;
    self.btnCheckAnt2.enabled = NO;
    self.btnCheckAnt3.enabled = NO;
    self.btnCheckAnt4.enabled = NO;
    self.setButton.enabled = NO;
    self.getButton.enabled = NO;
    self.tagViewController.tableView.allowsSelection = NO;
    _countNum ++;
    BOOL isNew = TRUE;
    NSString *pcEpc = @"";
    if (PC && ![@"" isEqualToString:PC] && EPC && ![@"" isEqualToString:EPC]) {
        pcEpc = [PC stringByAppendingString:EPC];
    }
    if ([pcEpc isEqualToString:@""]) {
        return;
    }
    NSData *dataRaw = [self dataWithHexString:pcEpc];
    if (dataRaw == nil) {
        return;
    }
    /* New data verification work */
    for(int i=0; i<tagModel.arrTags.count;i++)
    {
        NSDictionary *dic    = [tagModel.arrTags objectAtIndex:i];
        NSString     *oldPcEpc = [dic objectForKey:df_CELL_TAG_INFO];
        
        
        /* If it was previous data*/
        if ([oldPcEpc isEqualToString:pcEpc])
        {
            int nCount = [[dic objectForKey:df_CELL_TAG_COUNT] intValue]+1;
            NSString *strCount = [NSString stringWithFormat:@"%d",nCount];
            
            NSDictionary *inserDic  = [NSDictionary dictionaryWithObjectsAndKeys:
                                       pcEpc, df_CELL_TAG_INFO,
                                       strCount, df_CELL_TAG_COUNT,
                                       antenna,df_CELL_TAG_ANT,
                                       RSSI,df_CELL_TAG_RSSI,
                                       dataRaw,df_CELL_TAG_RAW,nil];
            
            [tagModel.arrTags replaceObjectAtIndex:i withObject:inserDic];
            isNew = FALSE;
            break;
        }
    }
    /* In the case of new data */
    if(isNew)
    {
        NSString *strCount = @"1";
        NSDictionary *inserDic  = [NSDictionary dictionaryWithObjectsAndKeys:
                                   pcEpc, df_CELL_TAG_INFO,
                                   strCount, df_CELL_TAG_COUNT,
                                   antenna,df_CELL_TAG_ANT,
                                   dataRaw,df_CELL_TAG_RAW,nil];
        
        [tagModel.arrTags addObject:inserDic];
        [self playBeepSound];
    }
    dispatch_async(dispatch_get_main_queue(),^{
        [self.tagViewController updateData];
        [self.labelTags setText:[NSString stringWithFormat:@"%d Tags",(int)[self->tagModel.arrTags count]]];
        [self.labelCount setText:[NSString stringWithFormat:@"%ld", (long)self->_countNum]];
    });
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didStartInventoryExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [_btnRead setEnabled:NO];
        [_btnCheckAnt1 setEnabled:NO];
        [_btnCheckAnt2 setEnabled:NO];
        [_btnCheckAnt3 setEnabled:NO];
        [_btnCheckAnt4 setEnabled:NO];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"Start Inventory Error"
                                                                       message:[NSString stringWithFormat:@"%x", statusCode]
                                                                preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"Cancel"
                                                         style:UIAlertActionStyleDefault
                                                       handler:nil];
        [alert addAction:cancel];
        [self presentViewController:alert animated:YES completion:nil];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didStopInventoryExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [_btnRead setEnabled:YES];
    [_btnCheckAnt1 setEnabled:YES];
    [_btnCheckAnt2 setEnabled:YES];
    [_btnCheckAnt3 setEnabled:YES];
    [_btnCheckAnt4 setEnabled:YES];
    
    self.btnNetwork.enabled = YES;
    self.btnMore.enabled = YES;
    self.btnSearch.enabled = YES;
    self.setButton.enabled = YES;
    self.getButton.enabled = YES;
    self.tagViewController.tableView.allowsSelection = YES;
    
    if (statusCode != ASP51NV2ExecutionStatusSuccess) {
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"Stop Inventory Error"
                                                                       message:[NSString stringWithFormat:@"%x", statusCode]
                                                                preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"Cancel"
                                                         style:UIAlertActionStyleDefault
                                                       handler:nil];
        [alert addAction:cancel];
        [self presentViewController:alert animated:YES completion:nil];
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
    } else {
        [Utils hiddenLoadingView];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didSetAntennaPortsStatusExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [Utils showAlert:@"Success" message:@"Set Antenna" view:self];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Set Antenna Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedAntennaPortsStatus:(BOOL)antenna1IsOpen antenna2:(BOOL)antenna2IsOpen antenna3:(BOOL)antenna3IsOpen antenna4:(BOOL)antenna4IsOpen executionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        ant1 = antenna1IsOpen;
        ant2 = antenna2IsOpen;
        ant3 = antenna3IsOpen;
        ant4 = antenna4IsOpen;
        if (ant1) {
            [_btnCheckAnt1 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
        } else {
            [_btnCheckAnt1 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
        }
        if (ant2) {
            [_btnCheckAnt2 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
        } else {
            [_btnCheckAnt2 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
        }
        if (ant3) {
            [_btnCheckAnt3 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
        } else {
            [_btnCheckAnt3 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
        }
        if (ant4) {
            [_btnCheckAnt4 setImage:[UIImage imageNamed:@"checked.png"] forState:UIControlStateNormal];
        } else {
            [_btnCheckAnt4 setImage:[UIImage imageNamed:@"uncheck.png"] forState:UIControlStateNormal];
        }
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Get Antenna Fail" message:[NSString stringWithFormat:@"%d", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 defaultSettingSuccessed:(BOOL)isSuccessed errorData:(NSMutableDictionary *)errorData{
    [Utils hiddenLoadingView];
    if (isSuccessed) {
        [Utils showAlert:@"Success" message:@"Setting" view:self];
    } else {
        [self ASP51NV2SettingGetReadyErrorMessage:errorData];
    }
}

- (void)ASP51NV2SettingGetReadyErrorMessage:(NSMutableDictionary *)dictionary{
    NSMutableString *errString = [[NSMutableString alloc] init];
    for (NSNumber *keyNumber in [dictionary allKeys]) {
        [errString appendString:[NSString stringWithFormat:@"%@:%@\n", keyNumber, [dictionary objectForKey:keyNumber]]];
    }
    if (![@"" isEqualToString:errString]) {
        [Utils showAlert:nil message:errString view:self];
    }
}

- (void)showAlertViewIPs
{
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"Found Device"
                                                                   message:@"Please select device IP"
                                                            preferredStyle:UIAlertControllerStyleAlert];
    
    for (int i = 0; i < [arrIPs count]; i++)
    {
        UIAlertAction *ip = [UIAlertAction actionWithTitle:[arrIPs objectAtIndex:i]
                                                     style:UIAlertActionStyleDefault
                                                   handler:^(UIAlertAction * action) {
            self->selectIP = [self->arrIPs objectAtIndex:i];
            [self->mngr connectServerWithIP:self->selectIP remoteport:5000]
            ;}];
        [alert addAction:ip];
    }
    
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"Cancel"
                                                     style:UIAlertActionStyleDefault
                                                   handler:nil];
    [alert addAction:cancel];
    
    UIBarButtonItem *button;
    alert.popoverPresentationController.barButtonItem = button;
    alert.popoverPresentationController.sourceView = self.view;
    [self presentViewController:alert animated:YES completion:nil];
}

- (void)enableUis:(BOOL)isEnable
{
    if(isEnable)
    {
        self.labelIP.text = @"Connected";
        self.labelIP.text = [NSString stringWithFormat:@"%@",selectIP ];
        [self.viewBottom setHidden:NO];
        [self.btnMore setEnabled:YES];
    } else {
        self.labelIP.text = @"Disconnected";
        [self.viewBottom setHidden:YES];
        [self.btnMore setEnabled:NO];
        [self.btnSearch setEnabled:YES];
    }
}

- (NSData*)dataWithHexString:(NSString*)str{
    
    if (!str || [str length] == 0) {
        return nil;
    }
    
    NSMutableData *hexData = [[NSMutableData alloc] initWithCapacity:8];
    NSRange range;
    if ([str length] % 2 == 0) {
        range = NSMakeRange(0, 2);
    } else {
        range = NSMakeRange(0, 1);
    }
    for (NSInteger i = range.location; i < [str length]; i += 2) {
        unsigned int anInt;
        NSString *hexCharStr = [str substringWithRange:range];
        NSScanner *scanner = [[NSScanner alloc] initWithString:hexCharStr];
        
        [scanner scanHexInt:&anInt];
        NSData *entity = [[NSData alloc] initWithBytes:&anInt length:1];
        [hexData appendData:entity];
        
        range.location += range.length;
        range.length = 2;
    }
    return hexData;
    
}
@end
